<script>
import { GlButton, GlCard } from '@gitlab/ui';
import CodeDisplay from './code_highlight.vue';

export default {
  name: 'RateCode',
  components: {
    GlButton,
    GlCard,
    CodeDisplay,
  },
  props: {
    name: {
      type: String,
      required: true,
    },
    language: {
      type: String,
      required: true,
    },
    source: {
      type: String,
      required: false,
      default: '',
    },
    showRateControls: {
      type: Boolean,
      required: false,
      default: false,
    },
    isSubmitting: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  computed: {
    finalSource() {
      return this.test ? this.test.result : this.source;
    },
    isDisabled() {
      return this.isSubmitting;
    },
  },
  async mounted() {},
  methods: {
    vote(value) {
      this.$emit('vote', value);
    },
  },
};
</script>

<template>
  <div class="">
    <gl-card class="gl-mt-6">
      <template #header> {{ name }} </template>
      <template #default>
        <code-display
          :key="source"
          :language="language"
          :source="source"
        ></code-display>
      </template>
      <template #footer>
        <div v-if="showRateControls" class="gl-display-flex">
          <div class="gl-text-align-right gl-min-h-6">
            <span>Does this code look good? </span>
            <gl-button
              category="secondary"
              variant="success"
              size="small"
              :selected="false"
              :block="false"
              :disabled="isDisabled"
              class="gl-ml-3"
              icon="thumb-up"
              @click="vote('thumbsUp')"
            >
            </gl-button>
            <gl-button
              category="secondary"
              variant="danger"
              size="small"
              :selected="false"
              :block="false"
              :disabled="isDisabled"
              class="gl-ml-3"
              icon="thumb-down"
              @click="vote('thumbsDown')"
            >
            </gl-button>
          </div>
        </div>
        <div v-else class="gl-min-h-6">
          This input is used to generate the code below
        </div>
      </template>
    </gl-card>
  </div>
</template>

<style scoped></style>
